package com.sun.corba.se.impl.util;

import java.util.EmptyStackException;
import java.util.Stack;

class RepositoryIdPool extends Stack
{
    private static int MAX_CACHE_SIZE;
    private RepositoryIdCache cache;
    
    RepositoryIdPool() {
    }
    
    public final synchronized RepositoryId popId() {
        try {
            return (RepositoryId)super.pop();
        }
        catch (EmptyStackException ex) {
            this.increasePool(5);
            return (RepositoryId)super.pop();
        }
    }
    
    final void increasePool(int i) {
        for (; i > 0; --i) {
            this.push(new RepositoryId());
        }
    }
    
    final void setCaches(RepositoryIdCache cache) {
        this.cache = cache;
    }
    
    static {
        RepositoryIdPool.MAX_CACHE_SIZE = 4;
    }
}
